﻿using System.Collections.Generic;

namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Tree {
  public class TreeNode<T> {
    public T Value { get; set; }
    public IList<TreeNode<T>> Children { get; private set; }

    public TreeNode() {
      Children = new List<TreeNode<T>>();
    }

    public TreeNode(T value) : this() {
      Value = value;
    }

    public void Add(T value) {
      Children.Add(new TreeNode<T>(value));
    }

    public void AddNode(TreeNode<T> node) {
      Children.Add(node);
    }

    public void ReplaceNode(int index, TreeNode<T> node) {
      Children[index] = node;
    }
  }
}
